<html lang=en>
 <head>
  <meta charset=UTF-8><meta name=viewport
      content="width=device-width, initial-scale=1">
  <title>CLAW CPLEX</title>
  <link rel=stylesheet type=text/css
        href=theme.css>
  <script type=text/javascript src=jquery.js></script>
  <script type=text/javascript src=toc.js></script>
  <link rel=stylesheet type=text/css
        href=highlight.min.css>
  <script type=text/javascript src=highlight.min.js></script>
  <script type=text/javascript>hljs.highlightAll();</script>
  <script type=text/javascript>
             MathJax = {
               tex: {
                 inlineMath: [['$','$']],
                 processEscapes: true
               }
             };
        </script>
  <script type=text/javascript
          src=https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-svg.js></script>
  <script type=text/javascript>$(document).ready(function() {$('a:has(img)').css('border-bottom', 'none')})</script>
 </head>
 <body>
  <div class=page><div class=sidebar><div class=header><form class=search method=GET action="search/">
      <input type=text name=q>
      <input type=submit value=Search><span id=search-progress></span>
     </form>
    </div><div class=content><div class=page-toc><ul><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40INDEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40INDEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">CLAW CPLEX</a></p><ul><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex</a></p><ul><li><p><a href="#claw-cplex-asdf-system-details" data-document="" data-node="claw-cplex-asdf-system-details">CLAW-CPLEX ASDF System Details</a></p></li><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex exports</a></p></li></ul></li><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex-config</a></p><ul><li><p><a href="#claw-cplex-config-asdf-system-details" data-document="" data-node="claw-cplex-config-asdf-system-details">CLAW-CPLEX-CONFIG ASDF System Details</a></p></li><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex-config exports</a></p></li></ul></li><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex-bindings</a></p><ul><li><p><a href="#claw-cplex-bindings-asdf-system-details" data-document="" data-node="claw-cplex-bindings-asdf-system-details">CLAW-CPLEX-BINDINGS ASDF System Details</a></p></li><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FPACKAGES-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FPACKAGES-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex-bindings packages</a></p></li><li><p><a href="#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29" data-document="" data-node="x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29">claw-cplex-bindings exports</a></p></li></ul></li></ul></li></ul>
     </div>
    </div><div class=footer>
     <a href=https://40ants.com/doc>[generated by 40ANTS-DOC]</a>
    </div>
   </div><div class=content role=main><h1>CLAW CPLEX<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40INDEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40INDEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>¶</a></h1><p>This project contains bindings for <a href="https://www.ibm.com/products/ilog-cplex-optimization-studio">IBM ILOG CPLEX Optimization Studio</a>, autogenerated using <a href="https://github.com/borodust/claw/">CLAW</a>. The bindings are very low-level, with no attempt made to Lisp-ify the result. It is strongly recommended that you do not use this project directly and instead use a project that provides a higher-level interface.</p><p><code>CPLEX</code> is a very useful and powerful piece of software. However it is proprietary, so it's not a good idea to count on its presence on any arbitrary machine. Therefore, this project is designed such it can be loaded into a <code>CL</code> process without having <code>CPLEX</code> installed (you still need <code>CPLEX</code> installed to actually <b>do</b> anything, though). You can then &quot;link&quot; against <code>CPLEX</code> at runtime.</p><p>Additionally, this project contains bindings for several versions of <code>CPLEX</code>. When the <code>CPLEX</code> foreign library is loaded, the appropriate bindings are chosen and exposed via the <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>claw-cplex-bindings</code></a> package. This allows the same executable to support a number of <code>CPLEX</code> versions being present at runtime.</p><p>The currently supported versions of <code>CPLEX</code> are:</p><ul><li><p>22.1</p></li><li><p>12.10</p></li></ul><p>This project contains several <code>ASDF</code> systems. The public systems are:</p><ul><li><p><b><code>claw-cplex</code> (<a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29"><code>1</code></a> <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>2</code></a>):</b> Loads everything except wrapper generation code (<code>CLAW</code>).</p></li><li><p><b><code>claw-cplex-bindings</code> (<a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>1</code></a> <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>2</code></a>):</b> Loads all packages that export the raw bindings. Does not load code for loading the <code>CPLEX</code> library nor binding the symbols in the <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>claw-cplex-bindings</code></a> package to the correct version specific functions, variables, etc.</p></li><li><p><b><code>claw-cplex-config</code> (<a href="#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29"><code>1</code></a> <a href="#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22claw-cplex-config-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22claw-cplex-config-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>2</code></a>):</b> Loads variables that can be set prior to loading <code>claw-cplex</code> (<a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29"><code>1</code></a> <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>2</code></a>) that affect its default behavior.</p></li></ul><p>The continued existance of any other system is not guaranteed.</p><p>This project provides several packages:</p><ul><li><p><b><code>claw-cplex-bindings-VERSION</code>:</b> Autogenerated bindings for <code>CPLEX</code> <code>VERSION</code>. You should not use any symbols from this package directly unless you need to depend on a specific version of <code>CPLEX</code>.</p></li><li><p><b><code>claw-cplex-bindings</code> (<a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>1</code></a> <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>2</code></a>):</b> This exports symbols with the same names as every version specific package. When <code>CPLEX</code> is loaded (discussed later), all exported symbols are unbound and then rebound to the same functions and values as the version specific package. You should use symbols from this package.</p></li><li><p><b><a href="#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29"><code>claw-cplex-config</code></a>:</b> This package exports symbols to control the default behavior of the system.</p></li><li><p><b><a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex</code></a>:</b> This package exports symbols needed to load and bind the <code>CPLEX</code> foreign library.</p></li></ul><h2>claw-cplex<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>¶</a></h2><p>Typically, your system will depend on the <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex</code></a> system. Loading this
system will load all the bindings, as well as some helper functions to actually
load the <code>CPLEX</code> foreign library, determine its version, and rebind functions and
variables in the <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>claw-cplex-bindings</code></a> package to the correct foreign
definitions.</p><h3 id="claw-cplex-asdf-system-details">CLAW-CPLEX ASDF System Details</h3><ul><li><p>Version: 0.2.0</p></li><li><p>Description: Thin wrapper over <code>IBM</code> <code>ILOG</code> <code>CPLEX</code></p></li><li><p>Licence: <code>BSD-2</code></p></li><li><p>Author: Model-based Embedded and Robotic Systems Group, <code>MIT</code></p></li></ul><h3>claw-cplex exports<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>
      ¶</a></h3><ul>
     <li><a
      href=#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/package.lisp#L1>
         [package]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29
         id=x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29>
          claw-cplex</a>
        </div></span></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3ACPLEX-LOADED-P-20FUNCTION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/bind.lisp#L51>
         [function]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3ACPLEX-LOADED-P-20FUNCTION-29
         id=x-28CLAW-CPLEX-3ACPLEX-LOADED-P-20FUNCTION-29>claw-cplex:cplex-loaded-p</a>
        </div></span><p>Return T if the <code>CPLEX</code> foreign library is loaded into the process.</p></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3ACPLEX-LOADED-AND-LINKED-P-20FUNCTION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/bind.lisp#L55>
         [function]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3ACPLEX-LOADED-AND-LINKED-P-20FUNCTION-29
         id=x-28CLAW-CPLEX-3ACPLEX-LOADED-AND-LINKED-P-20FUNCTION-29>
          claw-cplex:cplex-loaded-and-linked-p</a>
        </div></span><p>Return T if the <code>CPLEX</code> foreign library is loaded into the process and the
<code>claw-cplex-bindings</code> (<a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>1</code></a> <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>2</code></a>) package's symbols are bound to the correct version
specific values.</p></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/bind.lisp#L103>
         [function]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29
         id=x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29>
          claw-cplex:ensure-cplex-loaded</a>
        </div></span><span class=locative-args>&amp;key (library-path config:\*libcplex-path\*)</span><p>Ensure that <code>CPLEX</code> has been loaded and all symbols exported from the
<a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>claw-cplex-bindings</code></a> package have been bound to the values/functions/etc. from
the appropriate version specific package. Returns <code>NIL</code> (if the library could not
be loaded) or a string naming the version of <code>CPLEX</code> that is loaded.</p><p>May signal a <a href="#x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29" data-document="" data-node="x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29"><code>unknown-cplex-version</code></a> condition if a version of <code>CPLEX</code> is loaded
which we do not have bindings for.</p><p>A specific library can be loaded using the <code>LIBRARY-PATH</code> argument.</p><p>If <code>LIBRARY-PATH</code> is <code>NIL</code>, the environment variable <code>CPLEX</code>_<code>STUDIO</code>_<code>BINARIES</code> is
checked. If it is set, it must point to a directory containing the <code>CPLEX</code>
binaries to load.</p><p>If <code>LIBRARY-PATH</code> is <code>NIL</code> and <code>CPLEX</code>_<code>STUDIO</code>_<code>BINARIES</code> is not set, this searchs
through some standard locations to try and find <code>CPLEX</code>, prefering newer versions
over older versions.</p><p>This function is automatically called when loaded if
<a href="#x-28CLAW-CPLEX-CONFIG-3A-2ALOAD-CPLEX-ON-LOAD-P-2A-20-28VARIABLE-29-29" data-document="" data-node="x-28CLAW-CPLEX-CONFIG-3A-2ALOAD-CPLEX-ON-LOAD-P-2A-20-28VARIABLE-29-29"><code>claw-cplex-config:*load-cplex-on-load-p*</code></a> is non-<code>NIL</code>.</p> </span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3ADUMP-HOOK-20FUNCTION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/bind.lisp#L161>
         [function]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3ADUMP-HOOK-20FUNCTION-29
         id=x-28CLAW-CPLEX-3ADUMP-HOOK-20FUNCTION-29>claw-cplex:dump-hook</a>
        </div></span><p>This function should be called when dumping an image.</p><p>It is automatically added to <code>UIOP</code>'s dump hooks if
<a href="#x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-DUMP-HOOK-P-2A-20-28VARIABLE-29-29" data-document="" data-node="x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-DUMP-HOOK-P-2A-20-28VARIABLE-29-29"><code>claw-cplex-config:*add-to-uiop-dump-hook-p*</code></a> is non-<code>NIL</code>.</p></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3ARESTORE-HOOK-20FUNCTION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/bind.lisp#L171>
         [function]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3ARESTORE-HOOK-20FUNCTION-29
         id=x-28CLAW-CPLEX-3ARESTORE-HOOK-20FUNCTION-29>claw-cplex:restore-hook</a>
        </div></span><p>This function should be called when loading an image.</p><p>It is automatically added to <code>UIOP</code>'s restore hooks if
<a href="#x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-RESTORE-HOOK-P-2A-20-28VARIABLE-29-29" data-document="" data-node="x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-RESTORE-HOOK-P-2A-20-28VARIABLE-29-29"><code>claw-cplex-config:*add-to-uiop-restore-hook-p*</code></a> is non-<code>NIL</code>.</p></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/bind.lisp#L5>
         [condition]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29
         id=x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29>
          claw-cplex:unknown-cplex-version</a>
        </div></span><span class=locative-args></span></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-3AUSE-VERSION-20-28RESTART-29-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/doc.lisp#L90>[restart]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-3AUSE-VERSION-20-28RESTART-29-29
         id=x-28CLAW-CPLEX-3AUSE-VERSION-20-28RESTART-29-29>claw-cplex:use-version</a>
        </div></span><span class=locative-args>new-version</span><p>Available when <a href="#x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29" data-document="" data-node="x-28CLAW-CPLEX-3AUNKNOWN-CPLEX-VERSION-20CONDITION-29"><code>unknown-cplex-version</code></a> error is signalled. Use this restart to
pretend the loaded <code>CPLEX</code> version is <code>NEW-VERSION</code>, and use the bindings generated
for <code>NEW-VERSION</code>.</p> </span>
    </ul><h2>claw-cplex-config<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>
      ¶</a></h2><p>The <a href="#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22claw-cplex-config-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22claw-cplex-config-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex-config</code></a> system loads the <a href="#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29"><code>claw-cplex-config</code></a> package, and allows
you to configure the <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex</code></a> system before loading it.</p><h3 id="claw-cplex-config-asdf-system-details">CLAW-CPLEX-CONFIG ASDF System Details</h3><ul><li><p>Version: 0.2.0</p></li><li><p>Description: Configuration for claw-cplex system</p></li><li><p>Licence: <code>BSD-2</code></p></li><li><p>Author: Model-based Embedded and Robotic Systems Group, <code>MIT</code></p></li></ul><h3>claw-cplex-config exports<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-CONFIG-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>
      ¶</a></h3><ul>
     <li><a
      href=#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/config.lisp#L1>
         [package]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29
         id=x-28-23A-28-2817-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-CONFIG-22-29-20PACKAGE-29>
          claw-cplex-config</a>
        </div></span></span>
    </ul><ul>
     <li><a
      href=#x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-DUMP-HOOK-P-2A-20-28VARIABLE-29-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/config.lisp#L10>
         [variable]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-DUMP-HOOK-P-2A-20-28VARIABLE-29-29
         id=x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-DUMP-HOOK-P-2A-20-28VARIABLE-29-29>
          claw-cplex-config:*add-to-uiop-dump-hook-p*</a>
        </div></span><span class=locative-args>t</span><p>If non-<code>NIL</code> when <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex</code></a> system is loaded, <a href="#x-28CLAW-CPLEX-3ADUMP-HOOK-20FUNCTION-29" data-document="" data-node="x-28CLAW-CPLEX-3ADUMP-HOOK-20FUNCTION-29"><code>claw-cplex:dump-hook</code></a> is added to
<code>UIOP</code>'s list of dump hooks.</p> </span>
    </ul><ul>
     <li><a
      href=#x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-RESTORE-HOOK-P-2A-20-28VARIABLE-29-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/config.lisp#L14>
         [variable]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-RESTORE-HOOK-P-2A-20-28VARIABLE-29-29
         id=x-28CLAW-CPLEX-CONFIG-3A-2AADD-TO-UIOP-RESTORE-HOOK-P-2A-20-28VARIABLE-29-29>
          claw-cplex-config:*add-to-uiop-restore-hook-p*</a>
        </div></span><span class=locative-args>t</span><p>If non-<code>NIL</code> when <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex</code></a> system is loaded, <a href="#x-28CLAW-CPLEX-3ARESTORE-HOOK-20FUNCTION-29" data-document="" data-node="x-28CLAW-CPLEX-3ARESTORE-HOOK-20FUNCTION-29"><code>claw-cplex:restore-hook</code></a> is added to
<code>UIOP</code>'s list of restore hooks.</p> </span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-CONFIG-3A-2ALIBCPLEX-PATH-2A-20-28VARIABLE-29-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/config.lisp#L18>
         [variable]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-CONFIG-3A-2ALIBCPLEX-PATH-2A-20-28VARIABLE-29-29
         id=x-28CLAW-CPLEX-CONFIG-3A-2ALIBCPLEX-PATH-2A-20-28VARIABLE-29-29>
          claw-cplex-config:*libcplex-path*</a>
        </div></span><span class=locative-args>nil</span><p>The default value for the <code>:LIBRARY-PATH</code> argument to
<a href="#x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29" data-document="" data-node="x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29"><code>claw-cplex:ensure-cplex-loaded</code></a> function.</p> </span>
    </ul><ul>
     <li><a
      href=#x-28CLAW-CPLEX-CONFIG-3A-2ALOAD-CPLEX-ON-LOAD-P-2A-20-28VARIABLE-29-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/config.lisp#L22>
         [variable]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-CONFIG-3A-2ALOAD-CPLEX-ON-LOAD-P-2A-20-28VARIABLE-29-29
         id=x-28CLAW-CPLEX-CONFIG-3A-2ALOAD-CPLEX-ON-LOAD-P-2A-20-28VARIABLE-29-29>
          claw-cplex-config:*load-cplex-on-load-p*</a>
        </div></span><span class=locative-args>t</span><p>If non-<code>NIL</code> when <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22claw-cplex-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex</code></a> system is loaded, <a href="#x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29" data-document="" data-node="x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29"><code>claw-cplex:ensure-cplex-loaded</code></a> is
automatically called.</p> </span>
    </ul><h2>claw-cplex-bindings<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>
      ¶</a></h2><p>The <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22claw-cplex-bindings-22-29-20ASDF-2FSYSTEM-3ASYSTEM-29"><code>claw-cplex-bindings</code></a> system loads the bindings for every supported version
of <code>CPLEX</code>.</p><h3 id="claw-cplex-bindings-asdf-system-details">CLAW-CPLEX-BINDINGS ASDF System Details</h3><ul><li><p>Version: 0.2.0</p></li><li><p>Description: Thin wrapper over <code>IBM</code> <code>ILOG</code> <code>CPLEX</code>, without functionality to load <code>CPLEX</code></p></li><li><p>Licence: <code>BSD-2</code></p></li><li><p>Author: Model-based Embedded and Robotic Systems Group, <code>MIT</code></p></li></ul><h3>claw-cplex-bindings packages<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FPACKAGES-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FPACKAGES-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>
      ¶</a></h3><p>You should not need to use any symbols from these packages directly. But they
are available in case you need to support only a very specific version of <code>CPLEX</code>.</p><ul>
     <li><a
      href=#x-28-23A-28-2824-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-1210-22-29-20PACKAGE-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/1210/package.lisp#L1>
         [package]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28-23A-28-2824-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-1210-22-29-20PACKAGE-29
         id=x-28-23A-28-2824-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-1210-22-29-20PACKAGE-29>
          claw-cplex-bindings-1210</a>
        </div></span><p>Bindings for <code>CPLEX</code> version 12.10</p></span>
    </ul><ul>
     <li><a
      href=#x-28-23A-28-2823-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-221-22-29-20PACKAGE-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/221/package.lisp#L1>
         [package]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28-23A-28-2823-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-221-22-29-20PACKAGE-29
         id=x-28-23A-28-2823-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-221-22-29-20PACKAGE-29>
          claw-cplex-bindings-221</a>
        </div></span><p>Bindings for <code>CPLEX</code> version 22.1</p></span>
    </ul><h3>claw-cplex-bindings exports<a class=header-link
     href=#x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29
     title="Permalink to this headline"
     id=x-28CLAW-CPLEX-3A-3A-40CLAW-CPLEX-BINDINGS-2FEXPORTS-2040ANTS-DOC-2FLOCATIVES-3ASECTION-29>
      ¶</a></h3><p>The <a href="#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29"><code>claw-cplex-bindings</code></a> package exports all symbols corresponding to foreign
variables and functions. The values of those symbols are bound to the correct
foreign definitions by <a href="#x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29" data-document="" data-node="x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29"><code>claw-cplex:ensure-cplex-loaded</code></a>.</p><ul>
     <li><a
      href=#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/packages.lisp#L1>
         [package]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29
         id=x-28-23A-28-2819-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-22-29-20PACKAGE-29>
          claw-cplex-bindings</a>
        </div></span><p>Exports symbols with names equal to the union of all symbols exported from the
version specific packages. Initially, all the variables are unbound and all
functions immediately signal a <a href="#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29" data-document="" data-node="x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29"><code>claw-cplex-bindings/unlinked:symbol-not-linked</code></a>
error. Use <a href="#x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29" data-document="" data-node="x-28CLAW-CPLEX-3AENSURE-CPLEX-LOADED-20FUNCTION-29"><code>claw-cplex:ensure-cplex-loaded</code></a> to bind all variable and functions to
the correct definitions for the version of <code>CPLEX</code> that has been loaded.</p></span>
    </ul><ul>
     <li><a
      href=#x-28-23A-28-2828-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-2FUNLINKED-22-29-20PACKAGE-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/packages.lisp#L12>
         [package]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28-23A-28-2828-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-2FUNLINKED-22-29-20PACKAGE-29
         id=x-28-23A-28-2828-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-BINDINGS-2FUNLINKED-22-29-20PACKAGE-29>
          claw-cplex-bindings/unlinked</a>
        </div></span><p>Exports symbols for signalling that a symbol is unlinked to a foreign
definition and remedying that.</p></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/packages.lisp#L27>
         [condition]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29
         id=x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29>
          claw-cplex-bindings/unlinked:symbol-not-linked</a>
        </div></span><span class=locative-args></span></span>
    </ul><ul>
     <li><a
      href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-NAME-20-2840ANTS-DOC-2FLOCATIVES-3AREADER-20CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-29-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/packages.lisp#L27>
         [reader]</a>
        <div class=reference-object
             style="display: inline-block">
         <a
         href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-NAME-20-2840ANTS-DOC-2FLOCATIVES-3AREADER-20CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-29-29
         id=x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-NAME-20-2840ANTS-DOC-2FLOCATIVES-3AREADER-20CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-29-29>
          claw-cplex-bindings/unlinked:symbol-not-linked-name</a>
        </div></span><span class=locative-args></span><span class=locative-args>(:name)</span></span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20-28RESTART-29-29></a>
      <span class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/src/doc.lisp#L95>[restart]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20-28RESTART-29-29
         id=x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20-28RESTART-29-29>
          claw-cplex-bindings/unlinked:link</a>
        </div></span><span class=locative-args>&amp;key library-path &amp;allow-other-keys</span><p>May be available when <a href="#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29" data-document="" data-node="x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ASYMBOL-NOT-LINKED-20CONDITION-29"><code>symbol-not-linked</code></a> error is signalled. Attempt to link
<code>CPLEX</code> and re-call the function.</p><p>Is not available if <a href="#x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29" data-document="" data-node="x-28-23A-28-2810-29-20BASE-CHAR-20-2E-20-22CLAW-CPLEX-22-29-20PACKAGE-29"><code>claw-cplex</code></a> package is not loaded or <code>CPLEX</code> has already
been linked.</p> </span>
    </ul><ul>
     <li><a href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20FUNCTION-29></a><span
      class=reference-bullet><span class=reference><a class=locative-type
        href=NIL/blob/8b45d8c138b5e9b1212b53a51e260d414777aefd/bindings/packages.lisp#L35>
         [function]</a>
        <div class=reference-object
             style="display: inline-block">
         <a href=#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20FUNCTION-29
         id=x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20FUNCTION-29>
          claw-cplex-bindings/unlinked:link</a>
        </div></span><span class=locative-args>&amp;rest args &amp;key condition library-path 
        &amp;allow-other-keys</span><p>Invoke the <a href="#x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20-28RESTART-29-29" data-document="" data-node="x-28CLAW-CPLEX-BINDINGS-2FUNLINKED-3ALINK-20-28RESTART-29-29"><code>link</code></a> restart associated with <code>CONDITION</code>.</p> </span>
    </ul>
   </div>
  </div>
 </body>
</html>